'Compilable Example:
#Compile Exe  "gbquicknotes.exe"
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

%Unicode = 1
#Include "Win32api.inc"
#Include "cgdiplus.inc"

#Resource Icon logo, "images\gbquicknotes.ico"
#Resource Icon xnew, "images\new.ico"
#Resource Icon xdelete, "images\delete.ico"
#Resource Icon xcopy, "images\copy.ico"
#Resource Icon xcopyall, "images\copyall.ico"
#Resource Icon xhighlight, "images\highlight.ico"
#Resource Icon xhelp, "images\help.ico"
#Resource Icon xedit, "images\edit.ico"
#Resource Icon xclear, "images\clear.ico"
#Resource Icon xfont, "images\font.ico"
#Resource Icon xbackup, "images\backup.ico"
#Resource Icon xrestore, "images\restore.ico"
#Resource Icon xwordwrap, "images\wordwrap.ico"
#Resource Icon xautosave, "images\autosave.ico"

$Ver = "1.02"
$DataFile = "files\gbquicknotes.txt"
$Delimiter = $CrLf + "++--;;" + $CrLf

Enum Equates Singular
   IDC_Toolbar = 500
   IDC_ListView
   IDC_TextBox
   IDC_StatusBar

   IDT_New          'Get from clipboard & Save
   IDT_Delete       'Remove & Save
   IDT_Copy         'Copy to clipboard
   IDT_CopyAll      'Copy to clipboard
   IDT_HighlightTitle 'highlight Title on focus
   IDT_Clear
   IDT_Edit
   IDT_Backup
   IDT_Restore
   IDT_Font
   IDT_WrapWords
   IDT_AutoSave
   IDT_Help

   IDM_Sep
   IDM_CutSelectedText
   IDM_CopySelectedText
   IDM_PasteClipboardText
   IDM_DeleteSelectedText
   IDM_CopyNote
   IDM_CopyAllNote
   IDM_DeleteNote
   IDM_Test
End Enum

Global hDlg,hFont,hFontC,hContext,hTextBox,hListView,ghHook,hContextLV As Dword
Global HighlightTitle,LastNote,NoteCount,OldTextBoxProc,FontSize,FontAttr,AutoSave As Long
Global WrapWords,ChangeInWork As Long, D(), DT() As String, FontName As WStringZ*%Max_Path

Function PBMain() As Long
   Dialog New Pixels, 0, "gbQuickNotes   v" + $ver,300,300,400,400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hdlg, "logo"
   CreateToolbar
   CreateListView
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   CreateTextBoxContextMenu
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr, rc As Rect
   Local temp$, title$, w,h,iResult As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         CreateTextBox
         BuildAcceleratorTable
         Font New "Tahoma",10,0 To hFont
         Control Set Font hDlg, %IDC_Toolbar, hFont
         Font New FontName, FontSize, FontAttr To hFontC
         SetControlFonts
         If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
         If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
         SetMenusAndToolbar
         LoadDArray $DataFile
         If NoteCount And LastNote Then
            ListView Select hDlg, %IDC_ListView, LastNote
            ListView_SetItemState hListView, LastNote-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
            Control Set Text hDlg, %IDC_Textbox, D(LastNote-1)
         End If
         Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Welcome to gbQuickNotes !"
      Case %WM_ContextMenu
         Select Case Cb.WParam
            Case GetDlgItem(hDlg, %IDC_ListView)
               w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
               TrackPopupMenu hContextLV, %TPM_LeftAlign, w, h, 0, hDlg, ByVal 0   'put context menu where mouse is
               Function = 0 : Exit Function
         End Select
      Case %WM_Size
         ResizeWindow
      Case %WM_Destroy
         ListView Get Count hDlg, %IDC_ListView To NoteCount
         If NoteCount Then
            ListView Get Select hDlg, %IDC_ListView To LastNote
         Else
            LastNote = 0
         End If
         Settings_INI "save"
         If AutoSave Then SaveDArray
         SetWindowLong GetDlgItem(hDlg, %IDC_TextBox), %GWL_WNDPROC, OldTextBoxProc   'un-subclass
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_TextBox
               Select Case Cb.CtlMsg
                  Case %EN_Change
                     ListView Get Select hDlg, %IDC_ListView To iResult
                     Control Get Text hdlg, %IDC_TextBox To temp$
                     D(iResult-1) = temp$
                     DT(iResult-1) = DateTime
                     title$ = Mid$(Parse$(temp$,$CrLf,1),1,30)
                     ListView Set Text hdlg, %IDC_ListView, iResult, 1, title$
                     ListView Set Text hDlg, %IDC_ListView, iResult, 2, DateTime
                     ChangeInWork = 1
                     'ListView Select hDlg, %IDC_ListView, iResult
                     'ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                  End Select
            Case %IDM_CutSelectedText     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_CopySelectedText    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_PasteClipboardText  : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_DeleteSelectedText  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_CopyNote
            Case %IDM_CopyAllNote
            Case %IDM_DeleteNote

            Case %IDT_New
               Clipboard Get Text To temp$
               If Len(temp$) Then
                  ReDim Preserve D(UBound(D)+1) : NoteCount = UBound(D)+1
                  ReDim Preserve DT(UBound(D))
                  title$ = Mid$(Parse$(temp$,$CrLf,1),1,30)
                  Array Insert D(0), temp$
                  Array Insert DT(0), DateTime
                  Control Set Text hDlg, %IDC_Textbox, D(0)
                  ListView Insert Item hDlg, %IDC_ListView, 1,0, title$
                  ListView Set Text hDlg, %IDC_ListView, 1, 2, DT(0)
                  ListView Select hDlg, %IDC_ListView, 1
                  ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
               Else
                  Beep
               End If
            Case %IDT_Delete
               Select Case NoteCount
                  Case 0  'No action
                  Case 1  'Last Note
                     ListView Reset hDlg, %IDC_ListView
                     ReDim D(0) : NoteCount = 0 : ReDim DT(0)
                     Control Set Text hDlg, %IDC_TextBox, ""
                  Case Else
                     ListView Get Select hDlg, %IDC_ListView To iResult
                     Array Delete D(iResult-1)
                     Array Delete DT(iResult-1)
                     ReDim Preserve D(UBound(D)-1) : NoteCount = UBound(D) + 1
                     ReDim Preserve DT(NoteCount)
                     Control Set Text hDlg, %IDC_TextBox, D(Min(NoteCount,iResult)-1)
                     ListView Delete Item hDlg, %IDC_ListView, iResult
                     ListView Select hDlg, %IDC_ListView, Min(NoteCount,iResult)
                     ListView_SetItemState hListView, Min(NoteCount,iResult)-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
               End Select
            Case %IDT_CopyAll
               Control Get Text hDlg, %IDC_TextBox To temp$
               Clipboard Reset : Clipboard Set Text temp$
            Case %IDT_Copy
               Control Get Text hDlg, %IDC_TextBox To temp$
               iResult = InStr(temp$,$CrLf)
               If iResult Then temp$ = Mid$(temp$,iResult+2)
               Clipboard Reset : Clipboard Set Text temp$
            Case %IDT_Clear
               If MsgBox("Delete all notes?", %MB_OkCancel + %MB_IconQuestion, "Delete All") = %IdOk Then
                  ListView Reset hDlg, %IDC_ListView
                  ReDim D(0) : NoteCount = 0 : ReDim DT(0)
                  Control Set Text hDlg, %IDC_TextBox, ""
               End If
            Case %IDT_Font
               SelectMainFont

            Case %IDT_AutoSave
               AutoSave Xor= 1

            Case %IDT_WrapWords
               WrapWords Xor= 1
               Control Kill hDlg, %IDC_TextBox
               CreateTextBox
               ListView Get Select hDlg, %IDC_Listview To iResult
               Control Set Text hDlg, %IDC_TextBox, D(iResult-1)
               Control Set Font hDlg, %IDC_TextBox, hFontC
               ResizeWindow
            Case %IDT_Edit
               SaveDArray   'necessary duplicate of what happens in WM_Destroy
               iResult = Shell ("notepad.exe " + $DataFile, 1)  'does not wait for it to close
               Dialog End hDlg
            Case %IDT_HighlightTitle
               HighlightTitle Xor=1
               SetMenusAndToolbar
            Case %IDT_Help
               iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbquicknotes.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_Test : SetDefaultValues
            Case %IDT_Backup
               If MsgBox("Back up Notes database?", %MB_OkCancel + %MB_IconQuestion, "Backup Notes") = %IdOk Then
                  If IsFile($DataFile) Then FileCopy $DataFile, $DataFile + ".bak"
               End If
            Case %IDT_Restore
               If MsgBox("Restore Notes database from backup?", %MB_OkCancel + %MB_IconQuestion, "Restore Notes") = %IdOk Then
                  If IsFile($DataFile+".bak") Then
                     LoadDArray $DataFile + ".bak"
                     If NoteCount And LastNote Then
                        ListView Select hDlg, %IDC_ListView, LastNote
                        ListView_SetItemState hListView, LastNote-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                        Control Set Text hDlg, %IDC_Textbox, D(LastNote-1)
                     End If
                  End If
               End If

         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_New To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_New            : @PTT.@lpszText = "Create New Note from Clipboard Content"
                        Case %IDT_Delete         : @PTT.@lpszText = "Delete Selected Note"
                        Case %IDT_Copy           : @PTT.@lpszText = "Copy Note to Clipboard (No Title)"
                        Case %IDT_Clear          : @PTT.@lpszText = "Delete All Notes"
                        Case %IDT_CopyAll        : @PTT.@lpszText = "Copy Note to Clipboard (With Title)"
                        Case %IDT_Edit           : @PTT.@lpszText = "Open gbQuickNotes File in NotePad and Close gbQuickNotes"
                        Case %IDT_Font           : @PTT.@lpszText = "Select Font for Notes"
                        Case %IDT_WrapWords      : @PTT.@lpszText = "Wrap Note Text"
                        Case %IDT_AutoSave       : @PTT.@lpszText = "AutoSave Notes Database When gbQuickNotes Closes"
                        Case %IDT_HighlightTitle : @PTT.@lpszText = "Highlight Title When TextBox Gets Focus"
                        Case %IDT_Backup         : @PTT.@lpszText = "Create Backup Note File"
                        Case %IDT_Restore        : @PTT.@lpszText = "Restore Backup Note File"
                        Case %IDT_Help           : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged
                     If ChangeInWork = 0 Then
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        If iResult Then Control Set Text hDlg, %IDC_TextBox, D(iResult-1)
                     End If
                     ChangeInWork = 0
                  Case %NM_DblClk
                     Control Get Text hDlg, %IDC_Textbox To temp$
                     Clipboard Reset
                     Clipboard Set Text temp$
               End Select
         End Select
   End Select
End Function

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_HighlightTitle, IIf(HighlightTitle,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_WrapWords, IIf(WrapWords,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AutoSave, IIf(AutoSave,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
'    Menu Set State hSettings, ByCmd %IDM_HighlightTitle, HighlightTitle * %MFS_Checked Or %MFS_Enabled
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "xnew"       '1
    ImageList Add Icon hImageList, "xdelete"    '2
    ImageList Add Icon hImageList, "xcopy"      '3
    ImageList Add Icon hImageList, "xhighlight" '4
    ImageList Add Icon hImageList, "xhelp"      '5
    ImageList Add Icon hImageList, "xcopyall"   '6
    ImageList Add Icon hImageList, "xedit"      '7
    ImageList Add Icon hImageList, "xclear"     '8
    ImageList Add Icon hImageList, "xfont"      '9
    ImageList Add Icon hImageList, "xbackup"    '10
    ImageList Add Icon hImageList, "xrestore"   '11
    ImageList Add Icon hImageList, "xwordwrap"  '12
    ImageList Add Icon hImageList, "xautosave"  '13

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_New, %BTNS_Button, "New"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Delete, %BTNS_Button, "Delete"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Clear, %BTNS_Button, "Delete All"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Edit, %BTNS_Button, "Edit"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Copy, %BTNS_Button, "Copy"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_CopyAll, %BTNS_Button, "CopyAll"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_Backup, %BTNS_Button, "Backup"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11,  %IDT_Restore, %BTNS_Button, "Restore"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Font, %BTNS_Button, "Font"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12, %IDT_WrapWords, %BTNS_Check, "WordWrap"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13, %IDT_AutoSave, %BTNS_Check, "AutoSave"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_HighlightTitle,  %BTNS_Check, "Highlight Title"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Help,  %BTNS_Button, "Help"
End Sub

Sub CreateListView
   Control Add ListView, hDlg, %IDC_ListView,"",10,60,240,400, %LVS_Report Or %LVS_ShowSelAlways Or %WS_TabStop Or %LVS_SingleSel Or %WS_TabStop, %WS_Ex_ClientEdge Or %WS_Ex_Left
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect 'Or %LVS_Ex_CheckBoxes
   ListView Insert Column hDlg, %IDC_ListView, 1, "Note Titles", 150, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Date/Time", 85, 0

   Menu New PopUp To hContextLV
   Menu Add String, hContextLV, "Delete Selected Note", %IDT_Delete, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Delete All Notes", %IDT_Clear, %MF_Enabled
'   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
'   Menu Add String, hContextLV, "Load Test Data", %IDM_Test, %MF_Enabled
End Sub

Sub CreateTextBox
   Local style&
   If WrapWords Then
      style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or _
               %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop
   Else
      style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
            Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
   End If
   Control Add TextBox, hDlg, %IDC_TextBox, "", 260,60,400,400, style&, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_TextBox To hTextBox
   OldTextBoxProc = SetWindowLong(hTextBox, %GWL_WndProc, CodePtr(NewTextBoxProc))  'subclass
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "750", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "HighlightTitle", "0", temp, %Max_Path, INIFileName:  HighlightTitle = Val(temp)
      Getprivateprofilestring "All", "LastNote", "1", temp, %Max_Path, INIFileName:  LastNote = Val(temp)
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName          : FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName           : FontAttr = Val(temp)
      Getprivateprofilestring "All", "WrapWords", "0", temp, %Max_Path, INIFileName          : WrapWords = Val(temp)
      Getprivateprofilestring "All", "AutoSave", "1", temp, %Max_Path, INIFileName           : AutoSave = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "HighlightTitle", Str$(HighlightTitle), INIFileName
      WritePrivateProfileString "All", "LastNote", Str$(LastNote), INIFileName
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "WrapWords", Str$(WrapWords), INIFileName
      WritePrivateProfileString "All", "AutoSave", Str$(AutoSave), INIFileName
   End If
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(7)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_A  : ac(c).cmd   = %IDT_CopyAll    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C  : ac(c).cmd   = %IDT_Copy       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd   = %IDT_Edit       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd   = %IDT_Font       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDT_New        : Incr c
'   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W  : ac(c).cmd   = %IDT_WrapWords  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_X  : ac(c).cmd   = %IDT_Delete     : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function NewTextBoxProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long, temp$
   Select Case Msg
      Case %WM_SetFocus     : SelectTitle
      Case %WM_KillFocus
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldTextBoxProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateTextBoxContextMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy",   %IDM_CopySelectedText,  %MF_Enabled
   Menu Add String, hContext, "Cut",    %IDM_CutSelectedText,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_PasteClipboardText,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_DeleteSelectedText,  %MF_Enabled
End Sub

Sub SelectTitle
   Local LineNumber, StartPos, LineLength As Long
   If HighlightTitle Then
      LineNumber = 0
      StartPos = SendMessage(hTextBox, %EM_LineIndex, LineNumber, 0)    'pos of 1st char in lineM
      LineLength = SendMessage(hTextBox, %EM_LineLength, StartPos, 0)   'length of line containing 1st char
      SendMessage(hTextBox, %EM_SetSel, StartPos, StartPos + LineLength) 'select character range
   Else
      Control Send hDlg, %IDC_Textbox, %EM_SetSel, -1, 0
   End If
End Sub

Function DateTime() As String
   Function = Left$(Date$,5) + " " + Left$(Time$,5)
End Function

Sub SetControlFonts
   Control Set Font hDlg, %IDC_TextBox, hFontC
   Control Set Font hDlg, %IDC_ListView, hFontC
   Control Set Font hDlg, %IDC_StatusBar, hFontC
End Sub

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long, temp$
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFontC
      SetControlFonts
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub SetDefaultValues
   ListView Reset hDlg, %IDC_ListView
   NoteCount = 3
   ReDim D(2)
   ReDim DT(2)
   D(0) = "One" + $CrLf + "This is line one!"
   D(1) = "Two" + $CrLf + "This is line two!"
   D(2) = "Three" + $CrLf + "This is line three!"
   DT(0) = DateTime : DT(1) = DT(0) : DT(2) = DT(0)
   Control Set Text hDlg, %IDC_Textbox, D(0)
   ListView Insert Item hDlg, %IDC_ListView, 1, 0, Mid$(Parse$(D(0),$CrLf,1),1,30)
   ListView Insert Item hDlg, %IDC_ListView, 2, 0, Mid$(Parse$(D(1),$CrLf,1),1,30)
   ListView Insert Item hDlg, %IDC_ListView, 3, 0, Mid$(Parse$(D(2),$CrLf,1),1,30)
   ListView Set Text hDlg, %IDC_ListView, 1, 2, DateTime
   ListView Set Text hDlg, %IDC_ListView, 2, 2, DateTime
   ListView Set Text hDlg, %IDC_ListView, 3, 2, DateTime
   LastNote = 1
   ListView Select hDlg, %IDC_ListView, LastNote
   ListView_SetItemState hListView, LastNote-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
   SaveDArray
End Sub

Sub SaveDArray
   Local title$, clock$, body$, i As Long
   Open $DataFile For Output As #1
   For i = 0 To UBound(D)
      ListView Get Text hDlg, %IDC_ListView, i+1, 2 To clock$
      Print #1, clock$
      Print #1, D(i) + IIf$(i=UBound(D),"",$Delimiter) ;
   Next i
   Close #1
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_TextBox, w - 270, h-85
   Control Set Size hDlg, %IDC_ListView, 240, h-85
End Sub

Sub LoadDArray(fName$)
   Local temp$, title$, i,iPos As Long, Clock$
   ListView Reset hDlg, %IDC_ListView
   'read notes
   Open fName$ For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1

   'Exit if file is empty
   If Len(temp$)=0 Then
      ReDim D(0) : NoteCount = 0 : ReDim DT(0)
      LastNote = 0
      Control Set Text hDlg, %IDC_TextBox, ""
      Exit Sub
   End If

   'Load into Array If Content found
   NoteCount = ParseCount(temp$,$Delimiter)
   LastNote = 1
   ReDim D(NoteCount-1)
   ReDim DT(NoteCount-1)
   Parse temp$, D(), $Delimiter

   'load into ListView
   For i = 0 To UBound(D)
      clock$ = Parse$(D(i),$CrLf,1)              'datetime
      title$ = Mid$(Parse$(D(i),$CrLf,2),1,30)   'title
      iPos = InStr(1,D(i),$CrLf)
      iPos = InStr(iPos,D(i),$CrLf)
      If iPos = 0 Then Iterate For
      D(i) = Mid$(D(i),iPos+2)    'body
      ListView Insert Item hDlg, %IDC_ListView, i+1, 0, title$
      ListView Set Text hDlg, %IDC_ListView, i+1, 2, Clock$
   Next i
End Sub
